#include <iostream>
#include <vector>

using namespace std;

#define VERBOSE

// Функція для обчислення полінома Лагранжа
float lagrangeInterpolation(const vector<float>& x, const vector<float>& y, float xi) {
    float result = 0;
    for (char i = 0; i < x.size(); ++i) {
        float term = y[i];
        for (char j = 0; j < x.size(); ++j) {
            if (j != i)
                term *= (xi - x[j]) / (x[i] - x[j]);
        }
        result += term;
#ifdef VERBOSE
        cout << "Додаємо " << term << " до результату... " << result << endl;
#endif
    }
    return result;
}

//Функція для обчислення полінома Ньютона
float newtonInterpolation(const vector<float>& x, const vector<float>& y, float xi) {
    vector<vector<float>> f(x.size(), vector<float>(x.size()));
    for (size_t i = 0; i < x.size(); ++i)
        f[i][0] = y[i];
    for (size_t j = 1; j < x.size(); ++j)
        for (size_t i = 0; i < x.size() - j; ++i)
            f[i][j] = (f[i + 1][j - 1] - f[i][j - 1]) / (x[i + j] - x[i]);
    float result = f[0][0];
    float term = 1.0;
    for (size_t j = 1; j < x.size(); ++j) {
        term *= (xi - x[j - 1]);
        result += f[0][j] * term;
#ifdef VERBOSE
        cout << "Рахуємо... " << result << endl;
#endif
    }
    return result;
}
int main() {
    vector<float> x = {0.101, 0.106, 0.111, 0.116, 0.121, 0.126, 0.131, 0.136, 0.141, 0.146};
    vector<float> y = {1.261, 1.276, 1.291, 1.306, 1.321, 1.336, 1.352, 1.367, 1.383, 1.399};
    
    float xi = 0.1102;
    
    // Обчислення і виведення результатів
    while(1){
    cout << "Рахування полінома Лагранжа...: " << endl << lagrangeInterpolation(x, y, xi) << endl;
    cout << "Рахування полінома Ньютона...: " << endl << newtonInterpolation(x, y, xi) << endl;
    cout << "Наведені розрахунки актуальні для x=" << xi << " Введіть інше значення, якщо цікаво дізнатися результат для нього." << endl;
    cin >> xi;
    }
    return 0;
}
